
---
Language: C
Language: Cpp

Standard: Cpp11
UseTab: Never
PointerAlignment: Right

IndentWidth: 4
TabWidth: 4
ColumnLimit: 120

AllowShortBlocksOnASingleLine: Empty
AllowShortIfStatementsOnASingleLine: Never
AllowShortCaseLabelsOnASingleLine: true
AllowShortFunctionsOnASingleLine: Inline
AllowShortLoopsOnASingleLine: false

AlignAfterOpenBracket : Align

IndentCaseLabels: true

BreakBeforeTernaryOperators : true

BreakBeforeBraces: Attach
BreakConstructorInitializers: BeforeColon
# BreakInheritanceList: BeforeColon

FixNamespaceComments: true

NamespaceIndentation: None
CompactNamespaces: true

AccessModifierOffset: -4
ConstructorInitializerAllOnOneLineOrOnePerLine: false

BraceWrapping:   
  AfterNamespace:  false # false

IndentPPDirectives : AfterHash 

ContinuationIndentWidth: 8

SpaceAfterCStyleCast: false
SpaceAfterLogicalNot: false
SpaceAfterTemplateKeyword: false
SpaceBeforeAssignmentOperators: true
SpaceBeforeCtorInitializerColon: true
SpaceBeforeCpp11BracedList: false

AlwaysBreakTemplateDeclarations: Yes
# AllowAllConstructorInitializersOnNextLine: true

ForEachMacros:   
  - foreach
  - Q_FOREACH
  - BOOST_FOREACH
  
SortIncludes: true
IncludeBlocks: Regroup
IncludeCategories:
  - Regex:           '^<boost/'
    Priority:        6
  - Regex:           '^<vulkan/'
    Priority:        8
  - Regex:           '^<GLFW/'
    Priority:        9
  - Regex:           '^<SDL/'
    Priority:        9
  - Regex:           '^<mono'
    Priority:        10
  - Regex:           '<[[:alnum:]_-]+>'
    Priority:        3
  - Regex:           '<[[:alnum:]./_-]+>'
    Priority:        4
  - Regex:           '^"third_party/.*'
    Priority:        15
  - Regex:           '^"(core|rendering|engine|application|scripting|ui|extra)/'
    Priority:        100

DeriveLineEnding : true
